import com.holub.asynch.Reader_writer;
import java.io.*;

class Flush_example
{
	public interface Flush_error_handler
	{	void error( IOException e );
	}

	private final OutputStream	out;
	private Reader_writer		lock = new Reader_writer();
	private byte[]				buffer;
	private int					length;

	public Flush_example( OutputStream out )
	{	this.out = out;
	}
	//...
	synchronized void flush( final Flush_error_handler handler )
	{	new Thread()				//#new
		{	int 	length; 
			byte[]	copy;

			{	length = Flush_example.this.length;		//#constructor
				copy   = new byte[length];
				System.arraycopy(Flush_example.this.buffer, 0, copy, 0, length);
				Flush_example.this.length = 0;
			}

			public void run()
			{	try
				{	lock.request_write();
					out.write( copy, 0, length );
				}
				catch( IOException e )
				{	handler.error(e);	//#error
				}
				finally
				{	lock.write_accomplished();
				}
			}
		}.start();
	}
}
